# TBasic3DExportFilter Class Reference
[Base Classes for plugins]

Inheritance diagram for TBasic3DExportFilter:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | QueryInterface (const MCIID &riid, void **ppvObj)
virtual uint32 MCCOMAPI | AddRef ()
virtual boolean MCCOMAPI | Prepare (I3DShScene *scene, I3DShTreeElement *fatherTree)
virtual boolean MCCOMAPI | WantsOptionDialog ()
virtual MCCOMErr MCCOMAPI | NeededDiskSpace (IMCFile *file, I3DShScene *scene, I3DShTreeElement *fatherTree, uint32 *diskSpace)
virtual MCCOMErr MCCOMAPI | DoExport (IMCFile *file, I3DShScene *scene, I3DShTreeElement *fatherTree)
virtual boolean MCCOMAPI | WantsPreview ()
virtual MCCOMErr MCCOMAPI | GetPreviewSize (int16 *sizeh, int16 *sizev)
virtual MCCOMErr MCCOMAPI | SetPreview (TMCPixelBucket *preview)
virtual boolean MCCOMAPI | WantsTempFile ()
virtual boolean MCCOMAPI | WantToSaveParameters ()

## Detailed Description

Basic 3D Export Filter class. Derive from this for a default implementation of I3DExExportFilter

See also:
  I3DExExportFilter

## Member Function Documentation

virtual uint32 MCCOMAPI TBasic3DExportFilter::AddRef | ( |  | ) | `[inline, virtual]`

Increments the reference count of the object

Reimplemented from TBasicDataExchanger.

virtual MCCOMErr MCCOMAPI TBasic3DExportFilter::DoExport | ( | IMCFile * | file,
|  | I3DShScene * | scene,
|  | I3DShTreeElement * | fatherTree |
| ) |  |  | `[virtual]`

Exports the subtree pointed by fatherTree into a file.

Parameters:

  | file | A pointer to the file that should be written
  | scene | The scene that contains the geometry that will be exported.
  | fatherTree | The root of the sub tree that needs to be exported. (It should never be NULL)

Implements I3DExExportFilter.

virtual MCCOMErr MCCOMAPI TBasic3DExportFilter::GetPreviewSize | ( | int16 * | sizeh,
|  | int16 * | sizev |
| ) |  |  | `[virtual]`

Returns the size of the preview.

Parameters:

  | sizeh | Horizontal size of the preview in pixels
  | sizev | Vertical size of the preview in pixels

Implements I3DExExportFilter.

virtual MCCOMErr MCCOMAPI TBasic3DExportFilter::NeededDiskSpace | ( | IMCFile * | file,
|  | I3DShScene * | scene,
|  | I3DShTreeElement * | fatherTree,
|  | uint32 * | diskSpace |
| ) |  |  | `[virtual]`

Returns the amount of disk space that is necessary to perform the export. This method is not used at this point.

Implements I3DExExportFilter.

virtual boolean MCCOMAPI TBasic3DExportFilter::Prepare | ( | I3DShScene * | scene,
|  | I3DShTreeElement * | fatherTree |
| ) |  |  | `[virtual]`

Is called before the actual export starts. Usually you do not need to implement this method.

Parameters:

  | scene | The scene from which we export.
  | fatherTree | A pointer to the top of the tree that should be exported.

Implements I3DExExportFilter.

virtual MCCOMErr MCCOMAPI TBasic3DExportFilter::QueryInterface | ( | const MCIID & | riid,
|  | void ** | ppvObj |
| ) |  |  | `[virtual]`

Check if the object supports a given interface and returns a pointer to that interface if it does. Note that QueryInterface will increment the reference count of the object by one if the interface is found.

Parameters:

  | riid | GUID of the interface
  | ppvObj | A pointer to the pointer being returned.

Reimplemented from TBasicDataExchanger.

virtual MCCOMErr MCCOMAPI TBasic3DExportFilter::SetPreview | ( | TMCPixelBucket * | preview | ) | `[virtual]`

Sets the rendered preview of the scene. The Shell will call this method if WantsPreview() returned true.

Parameters:

  | preview | A pointer to a pixelBucket that contains the rendered preview of the scene.

Implements I3DExExportFilter.

virtual boolean MCCOMAPI TBasic3DExportFilter::WantsOptionDialog | ( |  | ) | `[virtual]`

Returns true if an option dialog should be opened.

Implements I3DExExportFilter.

virtual boolean MCCOMAPI TBasic3DExportFilter::WantsPreview | ( |  | ) | `[virtual]`

Returns true if the exporter wants a preview of the scene included in the file. If you return true, then the Shell calls SetPreview with the corresponding image.

Implements I3DExExportFilter.

virtual boolean MCCOMAPI TBasic3DExportFilter::WantsTempFile | ( |  | ) | `[inline, virtual]`

Returns true if the you want to use a temporary file, false otherwise.

When you use a temporary file, the Shell will pass a file finishing '.tmp' to DoExport and then rename that file will the correct extension specified by your exporter resource. This is done so that you do not corrupt a preexisting file if there is an error during the export.

Implements I3DExExportFilter.

virtual boolean MCCOMAPI TBasic3DExportFilter::WantToSaveParameters | ( |  | ) | `[inline, virtual]`

Return true if you want the parameters of this exporter to be saved in the Carrara scene file.

Implements I3DExExportFilter.

The documentation for this class was generated from the following file:

- Basic3DImportExport.h